from traits.api import HasTraits, Range, Instance, \
                    on_trait_change
from traitsui.api import View, Item, HGroup
from tvtk.pyface.scene_editor import SceneEditor
from mayavi.tools.mlab_scene_model import \
                    MlabSceneModel
from mayavi.core.ui.mayavi_scene import MayaviScene

from numpy import linspace, load, log, max, min,  pi, cos, sin, where

import wx

def curve(n_mer, n_long):
    phi = linspace(0, 2*pi, 2000)
    return [ cos(phi*n_mer) * (1 + 0.5*cos(n_long*phi)),
            sin(phi*n_mer) * (1 + 0.5*cos(n_long*phi)),
            0.5*sin(n_long*phi),
            sin(phi*n_mer)]


class Visualization(HasTraits):
    meridional = Range(1, 30,  6)
    transverse = Range(0, 30, 11)
    scene      = Instance(MlabSceneModel, ())

    def __init__(self):
        # Do not forget to call the parent's __init__
        HasTraits.__init__(self)
        #x, y, z, t = curve(self.meridional, self.transverse)
        #self.plot = self.scene.mlab.plot3d(x, y, z, t, colormap='Spectral')
        s = load('WFL_ch0_array.npy')
        #s /= max(s)
        s = log(where(s<=0, 1e-20, s))
        print 'data shape', s.shape #(2048, 785)
        self.plot = self.scene.mlab.surf(
                        s[0:1024:4, :-16:4], 
                        colormap='jet', 
                        line_width=1,
                        #vmax=max(s),
                        #vmin=min(s),
                        warp_scale="auto")
        
    #@on_trait_change('meridional,transverse')
    def update_plot(self):
        #x, y, z, t = curve(self.meridional, self.transverse)
        #self.plot.mlab_source.set(x=x, y=y, z=z, scalars=t)
        pass

    # the layout of the dialog created
    view = View(Item('scene', editor=SceneEditor(scene_class=MayaviScene),
                    height=500, width=600, show_label=False),
                #HGroup(
                #        '_', 'meridional', 'transverse',
                #    ),
                )

class MainWindow(wx.Frame):
    def __init__(self, parent, id):
        wx.Frame.__init__(self, parent, id, 'Mayavi in Wx')
        self.visualization = Visualization()
        self.control = self.visualization.edit_traits(parent=self,
                                kind='subpanel').control
        self.Show()

app = wx.PySimpleApp()
frame = MainWindow(None, wx.ID_ANY)
app.MainLoop()
